/*########################################################################################################/
Hula Girl Widget for Konfabulator. Provides information about your eBay Feedback score.

Copyright (C) 2005 William Warby and Mudbubble Animation & Design

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General
Public License as published by the Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write
to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
/########################################################################################################*/

/*########################################################################################################/
Version History:

1.0.1 (October 2005)
	- Added meta-tags for author, company, copyright and image
	- Added Windows .ico icon to package

1.0.0 (June 2005)
	- Initial Release
/########################################################################################################*/

/*########################################################################################################/
Credits and Acknowledgements:

The animation and graphics for this widget were created by and are copyright of Mudbubble Animation & Design.
The owner of Mudbubble has kindly granted permission for me to use his animation within this widget. You
may not under any circumstances reuse or redistribute these images for any purpose without prior written
permission from Mudbubble.
/########################################################################################################*/

//Create image
imgHulaGirl = new Image();
imgHulaGirl.hOffset = 0;
imgHulaGirl.vOffset = 0;

//Create update timer
tmrUpdate = new Timer();
tmrUpdate.interval = 0.05;
tmrUpdate.onTimerFired = 'updateDisplay();';
tmrUpdate.ticking = true;

//Variables to keep track of frames
currentFrame = 1;
totalFrames = 82;
var frameImages = new Array();

//Scale the image according to preferences
setScaling(true);

function updateDisplay() {
	if (currentFrame >= totalFrames) currentFrame = 1;
	else currentFrame++;
	imgHulaGirl.src = frameImages[currentFrame - 1];
}

function setScaling(firstRun) {
	
	//Establish which image set to use (because smaller images are MUCH more enocomical for processor usage)
	var strImageSet = '';
	if ((preferences.size.value) < 50) {
		strImageSet = 100;
	} else {
		strImageSet = 200;
	}
		
	//Put all frame image filenames into an array (to save working it out on every onTimerFired event)
	for (x = 1;  x <= totalFrames; x++) {
		var strFrame = '';
		for (y = 0; y < (totalFrames.toString().length - x.toString().length); y++) {
			strFrame += '0';
		}
		strFrame += x.toString();
		strFrame = 'Resources/' + strImageSet.toString() + '/hula_girl_' + strFrame + '.png';
		frameImages[x - 1] = strFrame;
	}
	
	//Set the starting image
	if (firstRun) imgHulaGirl.src = frameImages[currentFrame - 1];
	
	//Set scaling percentage
	var intScaling = preferences.size.value / 100 * (200 / strImageSet);
	if (intScaling < 0.25) intScaling = 0.25;
	else if (intScaling > 1) intScaling = 1;
	
	//Scale window
	wndMain.width = strImageSet * intScaling;
	wndMain.height = strImageSet * intScaling;
	
	//Scale image
	imgHulaGirl.width = strImageSet * intScaling;
	imgHulaGirl.height = strImageSet * intScaling;
}

function preferencesChanged() {
	//Set scaling
	setScaling(false);
}